<template>
    <section>
        <main>
            <div class="container">
                <div class="row">

                    <div class="col-12 col-sm-12 col-md-10 col-lg-8 offset-sm-0 offset-md-1 offset-lg-2">
                        <div class="text-center py-4">
                            <h2 class="title">Contáctanos</h2>
                            <div class="d-flex justify-content-center">
                                <hr class="line-bottom">
                            </div>
                        </div>

                        <div class="alert alert-success" role="alert" v-if="success === 200">
                            Gracias por contactarnos, uno de nuestros asesores se comunicara con usted lo mas pronto
                            posible.
                        </div>

                        <div class="alert alert-danger" role="alert" v-if="success === 503">
                            Lo sentimos los datos no pudieron ser enviados, lo invitamos a intentarlo de nuevo
                        </div>

                        <div v-if="errors.length">
                            <b>Por favor corrige los siguientes errores</b>
                            <ul class="text-danger">
                                <li v-for="error in errors" v-bind:key="error">{{ error }}</li>
                            </ul>
                        </div>

                        <form @submit="checkForm">

                            <div class="row">

                                <div class="col-12 col-sm-12 col-md-6 mb-3">
                                    <label for="names" class="form-label fw-600">Nombres</label>
                                    <input type="text"
                                           class="form-control"
                                           id="names"
                                           v-model="form.names"
                                           required>
                                </div>

                                <div class="col-12 col-sm-12 col-md-6 mb-3">

                                    <label for="surnames" class="form-label fw-600">Apellidos</label>
                                    <input type="text" class="form-control" id="surnames"
                                           v-model="form.surnames" required>
                                </div>

                                <div class="col-12 col-sm-12 col-md-6 mb-3">
                                    <label for="email" class="form-label fw-600">Correo electrónico</label>
                                    <input type="email" class="form-control" id="email" v-model="form.email"
                                           required>
                                </div>

                                <div class="col-12 col-sm-12 col-md-6 mb-3">
                                    <label for="mobile" class="form-label fw-600">Celular</label>
                                    <input type="tel" class="form-control" id="mobile" v-model="form.mobile"
                                           required>
                                </div>

                                <div class="col-12 mb-3">
                                    <label class="form-label fw-600 ">Ciudad</label>
                                    <select class="form-control" id="country" v-model="form.country">
                                        <option v-for="option in options" v-bind:value="option">
                                            {{ option }}
                                        </option>
                                    </select>

                                </div>

                                <div class="col-12 mb-3">
                                    <div class="form-check">
                                        <input class="form-check-input"
                                               required
                                               name="check"
                                               type="checkbox"
                                               v-model="form.check"
                                               id="flexCheckDefault">
                                        <label class="form-check-label" for="flexCheckDefault">
                                            Declaro que he leído y acepto la Política de <a
                                                class="text-decoration-none"
                                                href="https://bancoserfinanza.com/politica-de-proteccion-de-datos-personales/">Protección
                                            de Datos
                                            Personales</a> y el <a class="text-decoration-none"
                                                                   href="https://bancoserfinanza.com/servicio-al-cliente/aviso-de-privacidad/">Aviso
                                            de Privacidad</a> del Banco Serfinanza.
                                        </label>
                                    </div>
                                </div>

                                <div class="col-12 mb-3 d-flex justify-content-center align-content-center">
                                    <template v-if="!sending">
                                        <button type="submit" class="btn btn-danger btn-send">Contactar</button>
                                    </template>
                                    <template v-else>
                                        <button type="submit" class="btn btn-danger btn-send" disabled>Contactando...
                                        </button>
                                    </template>
                                </div>

                            </div>
                        </form>
                    </div>
                </div>
            </div>

        </main>
    </section>
</template>

<script>

    import axios from "axios";

    export default {
        name: 'Home',
        data() {
            return {
                options: [],
                errors : [],
                sending: false,
                success: 0,
                form   : {
                    names   : '',
                    surnames: '',
                    email   : '',
                    mobile  : '',
                    country : '',
                    check   : false,
                }
            }
        },
        methods: {
            send: function () {

                let post = {
                    names   : this.form.names,
                    surnames: this.form.surnames,
                    email   : this.form.email,
                    mobile  : this.form.mobile,
                    country : this.form.country,
                };

                axios.post("/contact/form", post)
                    .then(result => {

                        this.form.names    = '';
                        this.form.surnames = '';
                        this.form.email    = '';
                        this.form.mobile   = '';
                        this.form.country  = '';
                        this.form.check    = false;
                        this.sending       = false;
                        this.success       = 200;

                    })
                    .catch(err => {
                        this.success = 503;
                    });

            },

            checkForm: async function (e) {

                e.preventDefault();

                this.errors  = [];
                this.success = 0;
                this.sending = false;

                if (!this.form.names) {
                    this.errors.push('El nombre es obligatorio');
                }

                if (!this.form.surnames) {
                    this.errors.push('El apellido es obligatorio');
                }

                if (!this.form.email) {
                    this.errors.push('El correo electronico es obligatorio');
                } else if (!this.validEmail(this.form.email)) {
                    this.errors.push('El correo electronico es obligatorio');
                }

                if (!this.form.mobile) {
                    this.errors.push('El numero de celular es obligatorio');
                }

                if (!this.form.country) {
                    this.errors.push('La ciudad es obligatorio');
                }

                if (!this.form.check) {
                    this.errors.push('Es necesario aceptar las politicas de datos y privacidad');
                }

                if (!this.errors.length) {
                    this.sending = true;
                    await this.send();
                }

            },

            validEmail: function (email) {
                const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                return re.test(email);
            }

        },

        mounted() {
            axios.get("/contact/form/country").then((result) => {
                this.options = result.data;
            })
        },
    }
</script>
